
program testbed;

{$R testbed.RES}

uses wincrt, WObjects, WinTypes, WinProcs, strings, StdDlgs, StdWnds,
     dialunit;

const

  cm_specparam = 101;
  cm_establink = 102;
  cm_hangup    = 103;

  cm_exit      = 001;

  cm_download  = 201;
  cm_upload    = 202;
  cm_movedown  = 203;
  cm_moveup    = 204;
  cm_update    = 205;
  cm_mailupdate= 206;

  cm_zipserver = 301;
  cm_zipclient = 302;

  cm_unzipserver = 401;
  cm_unzipclient = 402;

  cm_runserver = 501;
  cm_runclient = 502;
  cm_lnchserver= 503;
  cm_lnchclient= 504;

  cm_delServer = 601;
  cm_delClient = 602;

  cm_UseHelp      = 905;
  cm_HelpAbout    = 999;
                   
  cm_DialupStatus     = 145;
  cm_DialupBanner     = 146;
  cm_DialupBytes      = 147;
  cm_DialupElapsed    = 148;
  cm_DialupBPS        = 149;
  cm_DialupPercent    = 150;
  cm_CommandCompleted = 151;
  cm_ZipStatus        = 152;

type
  TTestBedApp = object(TApplication)
                  procedure InitMainWindow; virtual;
                  procedure InitInstance; virtual;
                end;

 pMultiFieldDlg  = ^TMultiFieldDlg;
 TMultiFieldDlg= object(Tdialog)
                   NumFields:integer;
                   procedure SetupWindow; virtual;
                   procedure EndDlg(ARetValue: Integer); virtual;
                   constructor Init(AParent: PWindowsObject; AName: PChar;aNumFields:integer);
                 end;

  PStatusWindow= ^TStatusWindow;
  TStatusWindow = object(TDlgWindow)
                    MessagesArea:plistbox;
                    MyParent : pMDIWindow; 
                    constructor Init(AParent: PWindowsObject;
                                     AName: PChar);
                    procedure SetupWindow; virtual;
                  end;

  PTTestBedWindow = ^TTestBedWindow;
  TTestBedWindow = object(TMDIWindow)
                     StatusWindow : pStatusWindow;
                     constructor Init(ATitle: PChar; AMenu: HMenu);
                     procedure SetupWindow; virtual;
                     procedure GetWindowClass(var AWndClass:TWndCLass); virtual;

                     (* Methods responding to user input... *)
                     procedure SpecParam(var Msg: TMessage);
                       virtual cm_First + cm_specparam;
                     procedure EstabLink(var Msg: TMessage);
                        virtual cm_First + cm_establink;
                     procedure Hangup(var Msg: TMessage);
                       virtual cm_First + cm_hangup;
                     procedure FileExit(var Msg: TMessage);
                       virtual cm_First + cm_exit;
                     procedure DownLoad(var Msg: TMessage);
                       virtual cm_First + cm_download;
                     procedure UpLoad(var Msg: TMessage);
                       virtual cm_First + cm_upload;
                     procedure MoveDown(var Msg: TMessage);
                       virtual cm_First + cm_movedown;
                     procedure MoveUp(var Msg: TMessage);
                       virtual cm_First + cm_moveup;
                     procedure UpdateClient(var Msg: TMessage);
                       virtual cm_First + cm_update;
                     procedure UpdateEZMail(var Msg: TMessage);
                       virtual cm_First + cm_mailupdate;
                     procedure ZipServer(var Msg: TMessage);
                       virtual cm_First + cm_zipserver;
                     procedure ZipClient(var Msg: TMessage);
                       virtual cm_First + cm_zipclient;
                     procedure UnZipServer(var Msg: TMessage);
                       virtual cm_First + cm_unzipserver;
                     procedure UnZipClient(var Msg: TMessage);
                       virtual cm_First + cm_unzipclient;
                     procedure RunServer(var Msg: TMessage);
                       virtual cm_First + cm_runserver;
                     procedure RunClient(var Msg: TMessage);
                       virtual cm_First + cm_runclient;
                     procedure LnchServer(var Msg: TMessage);
                       virtual cm_First + cm_lnchserver;
                     procedure LnchClient(var Msg: TMessage);
                       virtual cm_First + cm_lnchclient;
                     procedure DelServer(var Msg: TMessage);
                       virtual cm_First + cm_delserver;
                     procedure DelClient(var Msg: TMessage);
                       virtual cm_First + cm_delclient;
                     procedure UseHelp(var Msg: TMessage);
                       virtual cm_First + cm_UseHelp;
                     procedure HelpAbout(var Msg: TMessage);
                       virtual cm_First + cm_HelpAbout;

                     (* Methods responding to EZdialup messages... *)
                     procedure NewDialupStatus(var Msg:Tmessage);
                       virtual wm_user + cm_DialupStatus;
                     procedure NewDialupBanner(var Msg:Tmessage);
                       virtual wm_user + cm_DialupBanner;
                     procedure NewDialupBytes(var Msg:Tmessage);
                       virtual wm_user + cm_DialupBytes;
                     procedure NewDialupElapsed(var Msg:Tmessage);
                       virtual wm_user + cm_DialupElapsed;
                     procedure NewDialupBPS(var Msg:Tmessage);
                       virtual wm_user + cm_DialupBPS;
                     procedure NewDialupPercent(var Msg:Tmessage);
                       virtual wm_user + cm_DialupPercent;
                     procedure CommandCompleted(var Msg:Tmessage);
                       virtual wm_user + cm_CommandCompleted;
                     procedure NewZipStatus(var Msg:Tmessage);
                       virtual wm_user + cm_ZipStatus;

                     function RunDialog(Title,Label1,Label2,Label3:string;
                                  NumFields:integer):boolean; virtual;

  end;



var

  DialogTitle:string;
  FieldResults:array[1..10] of string;
  FieldLabels:array[1..10] of string;
  CommandSerialNumber:word;


                                     
Procedure AddNul(var s:string);
begin
    (* Make string null-terminated *)
    s[length(s)+1] := chr(0);
end;                          


constructor TStatusWindow.Init(AParent: PWindowsObject; AName: PChar);
begin
   TdlgWindow.init(AParent,ANAme);
   MyParent := pointer(aparent);
   MessagesArea := New(Plistbox, InitResource(@self, 101));
end;

procedure TStatusWindow.SetupWindow;
var s:string;
   ParentRect,winrect:trect;
begin
   TdlgWindow.SetupWindow;


end;


constructor TMultiFieldDlg.init(AParent: PWindowsObject; AName: PChar;aNumFields:integer);
begin
    tdialog.init(aparent,aname);

    NumFields := ANumFields;
end;

procedure TMultiFieldDlg.SetupWindow;
var i:integer;
begin
    tdialog.Setupwindow;

    for i := 1 to NumFields do addnul(FieldResults[i]);

    for i := 1 to NumFields do
       SetDlgItemText(hwindow,100+i,@FieldResults[i][1]);

    for i := 1 to NumFields do
      if FieldLabels[i] <> ''
      then begin
        Addnul(FieldLabels[i]);
        SetDlgItemText(hwindow,200+i,@FieldLabels[i][1]);
      end;

     addnul(DialogTitle);
    SetWindowText(hwindow,@DialogTitle[1]);

end;

procedure TMultiFieldDlg.EndDlg(ARetValue: Integer);
var i,j:integer;
    name:array[0..144] of char;
    s:string;
begin
   i := ARetValue;
   if i = id_ok then begin

        for j := 1 to NumFields do begin
            GetDlgItemText(hwindow,100+j,name,144);
            s := strpas(name);
            if s = '' then begin
               i := 3;
            end
            else begin
              FieldResults[j] := s;
              addnul(FieldResults[j]);
            end;
        end;
   end;
   Tdialog.EndDlg(i);

end;

procedure TTestBedWindow.SpecParam(var Msg: TMessage);
var i:integer;
begin

     FieldResults[1] := '9,555-1212';
     FieldResults[2] := 'COM2';
     FieldResults[3] := '19200,n,8,1';
     FieldResults[4] := 'ATZ';
     FieldResults[5] := 'AT E0 V1 X4 S0=0';
     FieldResults[6] := 'k:\ezdialup\someuser';
     FieldResults[7] := 'userpassword';
     FieldResults[8] := 'ezdialup.exe';

     for i := 1 to 8 do FieldLabels[i] := '';

     repeat
       (* Display dialog until no empty fields or Cancel pressed... *)
       i := Application^.ExecDialog(New(pMultiFieldDlg, Init(@Self, 'SessionSpecs',8)))
     until i <> 3;
     if i = 1 then begin
       (* Ok was pressed; give EZDialup its configuration... *)
       (* These routines MUST be executed before server-control *)
       (* commands are allowed*)
       SetDialingSequence(@FieldResults[1][1]);
       SetDialupCommPort(@FieldResults[2][1]);
       SetDialupCommConfig(@FieldResults[3][1]);
       SetModemInit1(@FieldResults[4][1]);
       SetModemInit2(@FieldResults[5][1]);
       SetLinkUserPath(@FieldResults[6][1]);
       SetLinkUserPassword(@FieldResults[7][1]);
       SetExecutablePath(@FieldResults[8][1]);

       SetDownloadBlockSize(4096);
       SetUploadBlockSize(4096);
    end;

    for i := 1 to 8 do FieldResults[i] := '';
end;

procedure TTestBedWindow.EstabLink(var Msg: TMessage);
begin
   EstablishDialupLink;
end;

procedure TTestBedWindow.Hangup(var Msg: TMessage);
begin
  AbortSession;
end;

procedure TTestBedWindow.FileExit(var Msg: TMessage);
begin
   PostMessage(hwindow,wm_close,0,0);
end;

procedure TTestBedWindow.Download(var Msg: TMessage);
begin
    if RunDialog('Download A File','Server File','Client File','',2)
    then CommandSerialNumber := StartDownload(@FieldResults[1][1],@FieldResults[2][1]);
end;

procedure TTestBedWindow.Upload(var Msg: TMessage);
begin
    if RunDialog('Upload A File','Server File','Client File','',2)
    then CommandSerialNumber := StartUpLoad(@FieldResults[2][1],@FieldResults[1][1]);
end;

procedure TTestBedWindow.MoveDown(var Msg: TMessage);
var p:pchar;
begin
    if RunDialog('Move File Down','Server File','Client File','',2)
    then CommandSerialNumber := StartMoveDown(@FieldResults[1][1],@FieldResults[2][1]);
end;

procedure TTestBedWindow.MoveUp(var Msg: TMessage);
var p:pchar;
begin
    if RunDialog('Move File Up','Server File','Client File','',2)
    then CommandSerialNumber := StartMoveUp(@FieldResults[2][1],@FieldResults[1][1]);
end;

procedure TTestBedWindow.UpdateClient(var Msg: TMessage);
var p:pchar;
begin
    if RunDialog('Update Client Directory Structure',
                 'Client Directory',
                 'Server Directory',
                 'Client Date File',3)
    then CommandSerialNumber := UpdateClientDirectory(@FieldResults[1][1],
                                                      @FieldResults[2][1],
                                                      @FieldResults[3][1]);
end;

procedure TTestBedWindow.UpdateEZmail(var Msg: TMessage);
var p:pchar;
begin
    if RunDialog('Update EZMail','Server Mailbox','Client Directory','',2)
    then CommandSerialNumber := EZMailUpdate(@FieldResults[1][1],@FieldResults[2][1]);
end;


procedure TTestBedWindow.ZipServer(var Msg: TMessage);
begin
    if RunDialog('Zip Server File(s)','Target File','Source File(s)','',2)
    then CommandSerialNumber := ZipServerFile(@FieldResults[1][1],@FieldResults[2][1]);
end;

procedure TTestBedWindow.ZipClient(var Msg: TMessage);
begin
    if RunDialog('Zip Client File(s)','Target File','Source File(s)','',2)
    then CommandSerialNumber := ZipClientFile(@FieldResults[1][1],@FieldResults[2][1]);
end;

procedure TTestBedWindow.UnZipServer(var Msg: TMessage);
begin
    if RunDialog('Un-Zip Server File(s)','Source Zip File','Target Directory','',2)
    then CommandSerialNumber := UnZipServerFile(@FieldResults[1][1],@FieldResults[2][1]);
end;

procedure TTestBedWindow.UnZipClient(var Msg: TMessage);
begin
    if RunDialog('Un-Zip Client File(s)','Source Zip File','Target Directory','',2)
    then CommandSerialNumber := UnZipClientFile(@FieldResults[1][1],@FieldResults[2][1]);
end;

procedure TTestBedWindow.RunServer(var Msg: TMessage);
begin
    if RunDialog('Run and Wait for Server Program','Program Path','','',1)
    then CommandSerialNumber := RunProgramOnServer(@FieldResults[1][1]);
end;

procedure TTestBedWindow.RunClient(var Msg: TMessage);
begin
    if RunDialog('Run and Wait for Client Program','Program Path','','',1)
    then CommandSerialNumber := RunProgramOnClient(@FieldResults[1][1]);
end;

procedure TTestBedWindow.LnchServer(var Msg: TMessage);
begin
    if RunDialog('Run and Forget Server Program','Program Path','','',1)
    then CommandSerialNumber := LaunchProgramOnServer(@FieldResults[1][1]);
end;

procedure TTestBedWindow.LnchClient(var Msg: TMessage);
begin
    if RunDialog('Run and Forget Client Program','Program Path','','',1)
    then CommandSerialNumber := LaunchProgramOnClient(@FieldResults[1][1]);
end;

procedure TTestBedWindow.DelServer(var Msg: TMessage);
begin
    if RunDialog('Delete File(s) on Server','File(s)','','',1)
    then CommandSerialNumber := DeleteFilesOnServer(@FieldResults[1][1]);
end;

procedure TTestBedWindow.DelClient(var Msg: TMessage);
begin
    if RunDialog('Delete File(s) on Client','File(s)','','',1)
    then CommandSerialNumber := DeleteFilesOnClient(@FieldResults[1][1]);
end;

procedure TTestBedWindow.NewDialupStatus(var Msg:Tmessage);
var p:pchar;
s:string;

begin
  p := pointer(msg.lparam);
  StatusWindow^.MessagesArea^.AddString(p);
  StatusWindow^.MessagesArea^.SetSelIndex(StatusWindow^.MessagesArea^.GetCount-1);

end;

procedure TTestBedWindow.NewDialupBanner(var Msg:Tmessage);
begin
  SetDlgItemText(StatusWindow^.hwindow,100,pointer(msg.lparam));
end;

procedure TTestBedWindow.NewDialupBytes(var Msg:Tmessage);
begin
  SetDlgItemText(StatusWindow^.hwindow,102,pointer(msg.lparam));
end;

procedure TTestBedWindow.NewDialupPercent(var Msg:Tmessage);
begin
  SetDlgItemText(StatusWindow^.hwindow,103,pointer(msg.lparam));
end;

procedure TTestBedWindow.NewDialupBPS(var Msg:Tmessage);
begin
  SetDlgItemText(StatusWindow^.hwindow,104,pointer(msg.lparam));
end;

procedure TTestBedWindow.NewDialupElapsed(var Msg:Tmessage);
begin
  SetDlgItemText(StatusWindow^.hwindow,105,pointer(msg.lparam));
end;

procedure TTestBedWindow.CommandCompleted(var Msg:Tmessage);
var s,s2:string;
begin                                 
    s := strpas(pointer(msg.lparam));
    str(msg.wparam,s2);
    s := concat('Completed command: ',s2,' - ',s);
    addnul(s);
    StatusWindow^.MessagesArea^.AddString(@s[1]);
    StatusWindow^.MessagesArea^.SetSelIndex(StatusWindow^.MessagesArea^.GetCount-1);

end;

procedure TTestBedWindow.NewZipStatus(var Msg:Tmessage);
begin
  SetDlgItemText(StatusWindow^.hwindow,106,pointer(msg.lparam));
end;

constructor TTestBedWindow.Init(ATitle: PChar; AMenu: HMenu);
begin
  cmdshow := sw_maximize;
  TMDIWindow.Init(Atitle,Amenu);
end;

procedure TTestBedWindow.SetupWindow;
var pt:tpoint;
msg:tmessage;
i:integer;
begin
  TMDIWindow.SetupWindow;
  SetParentWindow(hwindow);
  StatusWindow := New(PStatusWindow,Init(@Self,'Messages'));
  Application^.MakeWindow(StatusWindow);
end;

procedure TTestBedWindow.UseHelp(var Msg:TMessage);
begin
      WinHelp(HWindow, 'EZDIALUP.HLP', 3, 0);
end;


procedure TTestBedWindow.HelpABout(var Msg:TMessage);
var
   result:integer;
begin
   Application^.ExecDialog(new(pdialog,init(@self,'help')));
end;

procedure TTestBedWindow.GetWindowClass(var AWndClass:TWndClass);
begin
    TMDIWindow.GetWindowClass(AWndClass);
    AWndClass.hIcon := LoadIcon(HInstance, 'icon1');
end;

function TTestBedWindow.RunDialog(Title,Label1,Label2,Label3:string;
                                  NumFields:integer):boolean;
var i:integer;
    s:string;
begin
     DialogTitle := Title;
     FieldLabels[1] := Label1;
     FieldLabels[2] := Label2;
     FieldLabels[3] := Label3;
     repeat
        case NumFields of
          1 :s := 'OneField';
          2 :s := 'TwoFields';
          3 :s := 'ThreeFields';
        end;
        addnul(s);
        i := Application^.ExecDialog(New(pMultiFieldDlg, Init(@Self, @s[1],NumFields)))
     until i <> 3;
     if i = 1
     then RunDialog := true
     else RunDialog := false;
end;

procedure TTestBedApp.InitMainWindow;
begin
  MainWindow := New(PTTestBedWindow, Init('Dialup-Client Testbed Program - source included',
    LoadMenu(HInstance, 'Commands')));
end;

procedure TTestBedApp.InitInstance;
begin
  TApplication.InitInstance;
end;

var
  TestBedApp : TTestBedApp;

begin

  TestBedApp.Init('TestBedApp');
  TestBedApp.Run;
  TestBedApp.Done;
end.
